unit unitModify;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Spin;

type
  TFormModify = class(TForm)
    SpeedButton77: TSpeedButton;
    SpeedButton76: TSpeedButton;
    Notebook1: TNotebook;
    ModifyComboBox: TComboBox;
    ModifyEdit: TEdit;
    ModifySpinEdit: TSpinEdit;
    LabLimit: TMemo;
    procedure SpeedButton76Click(Sender: TObject);
    procedure SpeedButton77Click(Sender: TObject);
    procedure ModifyComboBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ModifyComboBoxKeyPress(Sender: TObject; var Key: Char);
    procedure ModifyComboBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    CmdNo : Integer;

    Procedure GetData(ACmd_No:Integer);
    Procedure SendCmd;
    Function  StrFormatCmp(StrSource, StrFormat:String):Boolean; //.. T:Ok, F:Error

    Procedure WriteDev(Cmd: String);


    //..2007/06/12
    Function  DopplerFrqStr(ADopplerFrq:Extended):String;
    Function  RayleighFrqStr(ADopplerFrq:Extended):String;
    Function  DelayStr(_Value:Extended):String;
    Function  Phasestr(_Value:Extended):String;
    Function  ATTStr  (_Value:Extended):String;
    Function  PhaseRefStr(_Value:Extended):String;
    Function  AbsDelayStr(ADopplerFrq:Extended):String;
    Function  IFStr(ADopplerFrq:Extended):String;
    Function  OutLaveStr(ADopplerFrq:Extended):String;

    //kenny............2008/08/12
    Function  RFFreqStr(FreqStr:string):String;
    Function  RayWaveCorrStr(ADopplerFrq:Extended):String;
    Function  NoiseCNStr(CNStr:string):String;
    Function  NoiseBWStr(ADopplerFrq:Extended):String;
  end;

var
  FormModify: TFormModify;

implementation
{$R *.dfm}
uses Form4408;


//============================
//  ####.## => #:0~9
//
Function  TFormModify.StrFormatCmp(StrSource, StrFormat:String):Boolean; //.. T:Ok, F:Error
begin

end;

procedure TFormModify.WriteDev(Cmd: String);
begin
   form1.Caption:=Cmd;
   form1.WriteDev(Cmd);
end;

procedure TFormModify.SendCmd;

  Procedure SendEdit(CMD:String; CharLen:Integer);
  begin
    if ( CharLen = Length(ModifyEdit.Text) ) then
    begin
      WriteDev(Format('%s%s',[CMD,ModifyEdit.Text]) );
    end else ShowMessage('Parameter Error !!');
  end;

    Function PathName(ATag:Integer):String;
    var StrBuf:String;
    begin
       Result:='';
       case (CmdNo mod 10) of
           1:  StrBuf:='M';
           2:  StrBuf:='H';
           3:  StrBuf:='L';
           4:  StrBuf:='Y';
           5:  StrBuf:='D';
           6:  StrBuf:='A';
           else Exit;
       end;

       case ((CmdNo div 10)-11 ) of
           0:  Result:=StrBuf + 'A';
           1:  Result:=StrBuf + 'B';
           2:  Result:=StrBuf + 'C';
           3:  Result:=StrBuf + 'D';
           4:  Result:=StrBuf + 'E';
           5:  Result:=StrBuf + 'F';
           6:  Result:=StrBuf + 'G';
           7:  Result:=StrBuf + 'H';
           8:  Result:=StrBuf + 'J';
           9:  Result:=StrBuf + 'K';
           10: Result:=StrBuf + 'L';
           11: Result:=StrBuf + 'M';
           else Result:='';
       end;
    end;

begin
  try
  case CmdNo of
     { ====<< General >>==== }
     101:  //.._CM  ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0: WriteDev('CM00'); //00: 4401A-DAX,
          1: WriteDev('CM01'); //01: 4401U-F01 Normal,
          2: WriteDev('CM02'); //02: 4401U-F01 Shift, 2digits fixed
        end;
     102:  //.._PM   ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0: WriteDev('PM04'); //04:  4 dB,
          1: WriteDev('PM09'); //09:  9 dB,
          2: WriteDev('PM15'); //15: 15 dB,
        end;
     103:  //SendEdit('DS',8); //.._DS   Edit
           WriteDev( Format('DS%s',[AbsDelayStr( StrToFloat(ModifyEdit.Text))])  );
     104:  //SendEdit('PS',6); //.._PS   Edit
           WriteDev( Format('PS%s',[PhaseRefStr( StrToFloat(ModifyEdit.Text))])  );
     105:  //.._GP   ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0: WriteDev('GP0'); //0: Same group,
          1: WriteDev('GP1'); //1: Diversity mode
        end;
     106:  //SendEdit('CR',3); //.._CR   Edit
           WriteDev( Format('CR%S',[RayWaveCorrStr(StrToFloat(ModifyEdit.Text))])  );
     107:  //.._PT   ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0:  WriteDev('PTC'); //C: Converter display
          1:  WriteDev('PTB'); //B: Basic setting display,
          2:  WriteDev('PT1'); //1
          3:  WriteDev('PT2'); //2
          4:  WriteDev('PT3'); //3
          5:  WriteDev('PT4'); //4
          6:  WriteDev('PT5'); //5
          7:  WriteDev('PT6'); //6
          8:  WriteDev('PT7'); //7
          9:  WriteDev('PT8'); //8
          10: WriteDev('PT9'); //9
        end;

     { ====<< PATH #1~12>>==== }
     111,121,131,141,151,161,
     171,181,191,201,211,221:  //.._MA_1
        if PathName(CmdNo)<>'' then
        begin
           Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
             0: WriteDev( Format('%s0',[PathName(CmdNo)]) );//OFF
             1: WriteDev( Format('%s1',[PathName(CmdNo)]) );//Static mode
             2: WriteDev( Format('%s2',[PathName(CmdNo)]) );//Doppler mode
             3: WriteDev( Format('%s3',[PathName(CmdNo)]) );//Rayleigh mode
           end;
        end;

     112,122,132,142,152,162,
     172,182,192,202,212,222:  //.._HA_1  [PHASE]
            //SendEdit(PathName(CmdNo),4);
            WriteDev( Format('%s%s',[PathName(CmdNo), Phasestr( StrToFloat(ModifyEdit.Text)) ]) );

     113,123,133,143,153,163,
     173,183,193,203,213,223:  //.._LA_1  [Doppler FREQ]
            SendEdit(PathName(CmdNo),6);
            //WriteDev( Format('%s%s',[PathName(CmdNo), DopplerFrqStr( StrToFloat(ModifyEdit.Text)) ]) );

     114,124,134,144,154,164,
     174,184,194,204,214,224:  //.._YA_1  [Rayleigh FREQ]
            SendEdit(PathName(CmdNo),3);
           // WriteDev( Format('%s%s',[PathName(CmdNo), DopplerFrqStr( StrToFloat(ModifyEdit.Text)) ]) );

     115,125,135,145,155,165,
     175,185,195,205,215,225:  //.._DA_1  [DELAY]
            //SendEdit(PathName(CmdNo),9);
            WriteDev( Format('%s%s',[PathName(CmdNo), DelayStr( StrToFloat(ModifyEdit.Text)) ]) );

     116,126,136,146,156,166,
     176,186,196,206,216,226:  //.._AA_1  [ATT]
            //SendEdit(PathName(CmdNo),4);
            WriteDev( Format('%s%s',[PathName(CmdNo), ATTStr( StrToFloat(ModifyEdit.Text)) ]) );



     { ====<< 4401A-DAx >>====}
     301: //SendEdit('FQ',7); //.. _FQ   Edit
          WriteDev( Format('FQ%s',[RFFreqStr(ModifyEdit.Text)])  );
     302: //SendEdit('OL',4); //.. _OL   Edit
          WriteDev( Format('OL%s',[OutLaveStr( StrToFloat(ModifyEdit.Text))])  );
     303: //SendEdit('FI',5); //.. _FI   Edit
          WriteDev( Format('FI%s',[IFStr( StrToFloat(ModifyEdit.Text))])  );
     304: //.. _AS   ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0: WriteDev('AS0');//..0: OFF,
          1: WriteDev('AS1');//..1: ON,
        end;
     305: //.. _NU   ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0: WriteDev('NU0');//..0: OFF,
          1: WriteDev('NU1');//..1: ON,
          2: WriteDev('NU9');//..9: THROUGH
        end;
     306: //.. _NT   ComboBox
        Case ModifyComboBox.Items.IndexOf(ModifyComboBox.Text) of
          0: WriteDev('NT0');//..0: OFF,
          1: WriteDev('NT1');//..1: ON,
        end;
     307: //SendEdit('CN',5); //.. _CN   Edit
          WriteDev( Format('CN%s',[NoiseCNStr( ModifyEdit.Text)])  );
     308: //SendEdit('BW',4); //.. _BW   Edit
          WriteDev( Format('BW%s',[NoiseBWStr( StrToFloat(ModifyEdit.Text))])  );

  end;//..END: Case ATag of .................................       }

  except
    ShowMessage('Parameter Error !!');
  end;
end;

Procedure TFormModify.GetData(ACmd_No:Integer);
    Procedure SetComboBox(ATag:Integer);
    var AComboBox:TComboBox;
    begin
      case ((CmdNo div 10)-11 ) of
         0: AComboBox:=form1._MA_1;
         1: AComboBox:=form1._MA_2;
         2: AComboBox:=form1._MA_3;
         3: AComboBox:=form1._MA_4;
         4: AComboBox:=form1._MA_5;
         5: AComboBox:=form1._MA_6;
         6: AComboBox:=form1._MA_7;
         7: AComboBox:=form1._MA_8;
         8: AComboBox:=form1._MA_9;
         9: AComboBox:=form1._MA_10;
         10:AComboBox:=form1._MA_11;
         11:AComboBox:=form1._MA_12;
       end;
       Notebook1.ActivePage:='ComboBox';
       ModifyComboBox.Items.Text := AComboBox.Items.Text;
       ModifyComboBox.Text := AComboBox.Text;
    end;


    Procedure SetEdit(ATag:Integer);
    var StrBuf:String;
    begin
      case (CmdNo mod 10)of
       2:case ((CmdNo div 10)-11 ) of
           0: StrBuf:=form1._HA_1.Text;
           1: StrBuf:=form1._HA_2.Text;
           2: StrBuf:=form1._HA_3.Text;
           3: StrBuf:=form1._HA_4.Text;
           4: StrBuf:=form1._HA_5.Text;
           5: StrBuf:=form1._HA_6.Text;
           6: StrBuf:=form1._HA_7.Text;
           7: StrBuf:=form1._HA_8.Text;
           8: StrBuf:=form1._HA_9.Text;
           9: StrBuf:=form1._HA_10.Text;
           10:StrBuf:=form1._HA_11.Text;
           11:StrBuf:=form1._HA_12.Text;
          end;
       3:case ((CmdNo div 10)-11 ) of
           0: StrBuf:=form1._LA_1.Text;
           1: StrBuf:=form1._LA_2.Text;
           2: StrBuf:=form1._LA_3.Text;
           3: StrBuf:=form1._LA_4.Text;
           4: StrBuf:=form1._LA_5.Text;
           5: StrBuf:=form1._LA_6.Text;
           6: StrBuf:=form1._LA_7.Text;
           7: StrBuf:=form1._LA_8.Text;
           8: StrBuf:=form1._LA_9.Text;
           9: StrBuf:=form1._LA_10.Text;
           10:StrBuf:=form1._LA_11.Text;
           11:StrBuf:=form1._LA_12.Text;
          end;
       4:case ((CmdNo div 10)-11 ) of
           0: StrBuf:=form1._YA_1.Text;
           1: StrBuf:=form1._YA_2.Text;
           2: StrBuf:=form1._YA_3.Text;
           3: StrBuf:=form1._YA_4.Text;
           4: StrBuf:=form1._YA_5.Text;
           5: StrBuf:=form1._YA_6.Text;
           6: StrBuf:=form1._YA_7.Text;
           7: StrBuf:=form1._YA_8.Text;
           8: StrBuf:=form1._YA_9.Text;
           9: StrBuf:=form1._YA_10.Text;
           10:StrBuf:=form1._YA_11.Text;
           11:StrBuf:=form1._YA_12.Text;
          end;
       5:case ((CmdNo div 10)-11 ) of
           0: StrBuf:=form1._DA_1.Text;
           1: StrBuf:=form1._DA_2.Text;
           2: StrBuf:=form1._DA_3.Text;
           3: StrBuf:=form1._DA_4.Text;
           4: StrBuf:=form1._DA_5.Text;
           5: StrBuf:=form1._DA_6.Text;
           6: StrBuf:=form1._DA_7.Text;
           7: StrBuf:=form1._DA_8.Text;
           8: StrBuf:=form1._DA_9.Text;
           9: StrBuf:=form1._DA_10.Text;
           10:StrBuf:=form1._DA_11.Text;
           11:StrBuf:=form1._DA_12.Text;
          end;
       6:case ((CmdNo div 10)-11 ) of
           0: StrBuf:=form1._AA_1.Text;
           1: StrBuf:=form1._AA_2.Text;
           2: StrBuf:=form1._AA_3.Text;
           3: StrBuf:=form1._AA_4.Text;
           4: StrBuf:=form1._AA_5.Text;
           5: StrBuf:=form1._AA_6.Text;
           6: StrBuf:=form1._AA_7.Text;
           7: StrBuf:=form1._AA_8.Text;
           8: StrBuf:=form1._AA_9.Text;
           9: StrBuf:=form1._AA_10.Text;
           10:StrBuf:=form1._AA_11.Text;
           11:StrBuf:=form1._AA_12.Text;
          end;
       End;

       Notebook1.ActivePage:='Edit';
       ModifyEdit.Text := StrBuf;
    end;
begin
  //caption:=Format('ATag:= %d',[ATag]);
  Self.Caption:=Format('%s',[form1.Caption]);
  CmdNo:=ACmd_No;
  LabLimit.Clear;

  case CmdNo of
     { ====<< General >>==== }
     101:  //.._CM
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._CM.Items.Text;
            ModifyComboBox.Text := form1._CM.Text;
         End;
     102:  //.._PM
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._PM.Items.Text;
            ModifyComboBox.Text := form1._PM.Text;
         End;
     103:  //.._DS
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._DS.Text;
            LabLimit.Text:='0000.045 ~ 5242.835 (uS)';
         End;
     104:  //.._PS
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._PS.Text;
            LabLimit.Text:='-5.000 ~ +0.000 ~ +5.000 (MHz)';
         End;
     105:  //.._GP
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._GP.Items.Text;
            ModifyComboBox.Text := form1._GP.Text;
         End;
     106:  //.._CR
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._CR.Text;
            LabLimit.Text:='0.0 ~ 1.0';
         End;
     107:  //.._PT
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._PT.Items.Text;
            ModifyComboBox.Text := form1._PT.Text;
         End;


     {PATH #1~12}
     111,121,131,141,151,161,
     171,181,191,201,211,221:  //.._MA_1
          SetComboBox(CmdNo);

     112,122,132,142,152,162,
     172,182,192,202,212,222:  //.._HA_1
         Begin
            SetEdit(CmdNo);
            LabLimit.Text:='-180 ~ +000~ +180';
         End;
     113,123,133,143,153,163,
     173,183,193,203,213,223:  //.._LA_1
         Begin
            SetEdit(CmdNo);
            LabLimit.Lines.Add('-999.9 ~ -100.0, -99.99 ~ -00.01  (HZ)');
            LabLimit.Lines.Add('+00.01 ~ +99.99, +100.0 ~ +999.9  (HZ)');
         End;
     114,124,134,144,154,164,
     174,184,194,204,214,224:  //.._YA_1
         Begin
            SetEdit(CmdNo);
            LabLimit.Lines.Add('1.0 ~ 9.9 (HZ)');
            LabLimit.Lines.Add('010 ~ 099 (HZ)');
            LabLimit.Lines.Add('100 ~ 500 (HZ)');
         End;
     115,125,135,145,155,165,
     175,185,195,205,215,225:  //.._DA_1
         Begin
            SetEdit(CmdNo);
            LabLimit.Text:='-2621.395 ~ +0000.000~ +2621.395 (uS) ';
         End;
     116,126,136,146,156,166,
     176,186,196,206,216,226:  //.._AA_1
         Begin
            SetEdit(CmdNo);
            LabLimit.Text:='00.0 ~ 59.9 (dB)';
         End;


     {4401A-DAx}
     301: //.. _FQ
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._FQ.Text;
            LabLimit.Lines.Add('0048.00~1000.00MHz;.00:Step 10KHz     ');
            LabLimit.Lines.Add('0048R00~1000R00MHz;R00:0/6~R05:5/6 MHz');
            LabLimit.Lines.Add('0048S00~1000S00MHz;S00:0/7~S06:6/7 MHz');
                (* 0048.00~1000.00
                   0048R00~1000R05
                   0048S00~1000R06  *)
         End;
     302: //.. _OL
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := floattostr(0 - strtofloat(form1._OL.Text));
            LabLimit.Text:='00.0 ~ -98.0 (dBm),Step 0.1dBm';
         End;
     303: //.. _FI
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._FI.Text;
            LabLimit.Text:='36.00 ~ 44.00 (MHz),Step 0.05MHZ';
         End;
     304: //.. _AS
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._AS.Items.Text;
            ModifyComboBox.Text := form1._AS.Text;
         End;
     305: //.. _NU
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._NU.Items.Text;
            ModifyComboBox.Text := form1._NU.Text;
         End;
     306: //.. _NT
         Begin
            Notebook1.ActivePage:='ComboBox';
            ModifyComboBox.Items.Text := form1._NT.Items.Text;
            ModifyComboBox.Text := form1._NT.Text;
         End;
     307: //.. _CN
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._CN.Text;
            LabLimit.Text:='-05.0 ~ +40.0 (dB)';
         End;
     308: //.. _BW
         Begin
            Notebook1.ActivePage:='Edit';
            ModifyEdit.Text := form1._BW.Text;
            LabLimit.Text:='0.43 ~ 9.99 (MHz)';
         End;
  end;//..END: Case ATag of .................................       }
end;

procedure TFormModify.SpeedButton76Click(Sender: TObject);
begin
   Close;
end;

procedure TFormModify.SpeedButton77Click(Sender: TObject);
begin
   SendCmd;
   form1.UpDataMon.Click; //..ק۰ʰ̦UpdateMonitor
   Close;
end;

//Error MsgBz.........kenny....2008/08/12
Function  TFormModify.DopplerFrqStr(ADopplerFrq:Extended):String;
var i:integer;
    StrBuf,_S:String;
begin

   if ADopplerFrq<0 then _S:='' else _S:= '+';

   if (ADopplerFrq<-100) or (ADopplerFrq>100)
     then StrBuf:= Format('%s%5.1f',[_S, ADopplerFrq]);

   if (ADopplerFrq>-100) and (ADopplerFrq<100)
     then StrBuf:= Format('%s%5.2f',[_S, ADopplerFrq]);

   for i:=1 to 5 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;

end;

Function  TFormModify.RayleighFrqStr(ADopplerFrq:Extended):String;
var i:integer;
   StrBuf:String;
begin

   if ADopplerFrq<1 then ADopplerFrq:=1;

   if (ADopplerFrq<10)
     then StrBuf:= Format('%2.1f',[ADopplerFrq])
     else StrBuf:= Format('%3.0f',[ADopplerFrq]);

   for i:=1 to 3 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;
end;

Function  TFormModify.DelayStr(_Value:Extended):String;
var i:integer;
    StrBuf,_S:String;
begin

   if _Value<0 then _S:='-' else _S:= '+';

   if (_Value<-2621.395) or (_Value>2621.395) then
   begin
      ShowMessage(Floattostr(_Value)+',DT');
   end;

   StrBuf:= Format('%8.3f',[ abs(_Value)]);

   for i:=1 to 9 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:= _S + StrBuf;

end;


Function  TFormModify.Phasestr(_Value:Extended):String;
var i:integer;
    StrBuf,_S:String;
begin

   if _Value<0 then _S:='-' else _S:= '+';

   if (_Value<-180) or (_Value>180) then
   begin
      ShowMessage(Floattostr(_Value)+',DT');
   end;

   StrBuf:= Format('%3.0f',[ Abs(_Value)]);

   for i:=1 to 4 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=_S+StrBuf;

end;


Function  TFormModify.ATTStr  (_Value:Extended):String;
var i,Len:integer;
    StrBuf,ABuf,_S:String;
begin

   if _Value<0 then _S:='' else _S:= '+';

   if (_Value<-0) or (_Value>59.9) then
   begin
      ShowMessage(Floattostr(_Value)+',DT');
   end;

   StrBuf:= Format('%3.1f',[ _Value]);
   Len:=Length(StrBuf);
   ABuf:='';


   for i:=1 to (4-Len) do
     ABuf := ABuf + '0';

   Result:=ABuf+StrBuf;

end;

Function  TFormModify.PhaseRefStr(_Value:Extended):String;
var i:integer;
    StrBuf,_S:String;
begin

   if _Value<0 then _S:='-' else _S:= '+';

   if (_Value<-5.000) or (_Value>5.000) then
   begin
      ShowMessage(Floattostr(_Value)+',DT');
   end;

   StrBuf:= Format('%1.3f',[ Abs(_Value)]);

   for i:=1 to 6 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=_S+StrBuf;

end;

Function  TFormModify.AbsDelayStr(ADopplerFrq:Extended):String;
var i:integer;
   StrBuf:String;
begin

   if ADopplerFrq<1 then ADopplerFrq:=1;

   StrBuf:= Format('%8.3f',[ADopplerFrq]);

   for i:=1 to 7 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;
end;

Function  TFormModify.IFStr(ADopplerFrq:Extended):String;
var i:integer;
   StrBuf:String;
begin
   if (ADopplerFrq<36.00) or (ADopplerFrq>44.00) then
   begin
      ShowMessage(Floattostr(ADopplerFrq)+',DT');
   end;

   if ADopplerFrq<1 then ADopplerFrq:=1;

   StrBuf:= Format('%5.2f',[ADopplerFrq]);

   for i:=1 to 3 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;
end;

Function  TFormModify.OutLaveStr(ADopplerFrq:Extended):String;
var i:integer;
   StrBuf:String;
begin
   if (ADopplerFrq<00.0) or (ADopplerFrq>98.0) then
   begin
      ShowMessage(Floattostr(ADopplerFrq)+',DT');
   end;

   if ADopplerFrq<1 then ADopplerFrq:=1;

   StrBuf:= Format('%4.1f',[ADopplerFrq]);

   for i:=1 to 3 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;
end;

//kenny...........2008/08/12
Function  TFormModify.RFFreqStr(FreqStr:string):String;
var i:integer;
   StrBuf,Freq:String;
   Efreq:Extended;
begin
   if Length(FreqStr)=7 then
     begin
       for i:=1 to 4 do
         begin
           if FreqStr[i]=' ' then
             FreqStr[i] := '0';
           Freq := Freq+FreqStr[i];
           Efreq := strtofloat(Freq);
         end;
       if (Efreq<48.00) or (Efreq>1000.00) then
         begin
           ShowMessage(floattostr(Efreq)+',DT');
         end;
     end else begin
       ShowMessage('Parameter Error !!');
     end;

   StrBuf:= Format('%S',[FreqStr]);
   Result:=StrBuf;
end;

Function  TFormModify.RayWaveCorrStr(ADopplerFrq:Extended):String;
var i:integer;
   StrBuf:String;
begin
   if (ADopplerFrq<0.0) or (ADopplerFrq>1.0) then
   begin
      ShowMessage(Floattostr(ADopplerFrq)+',DT');
   end;

   StrBuf:= Format('%1.1f',[ADopplerFrq]);

   if Length(strbuf) <> 3 then
     ShowMessage('Parameter Error !!');

   for i:=1 to 3 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;
end;

Function  TFormModify.NoiseCNStr(CNStr:string):String;
var i:integer;
   StrBuf,Freq:String;
   Efreq:Extended;
begin
   if Length(CNStr)=5 then
     begin
       for i:=2 to 5 do
         begin
           if CNStr[i]=' ' then
             CNStr[i] := '0';
           Freq := Freq+CNStr[i];
           Efreq := strtofloat(Freq);
         end;

       if CNStr[1]='-' then
         Efreq := 0 - Efreq;

       if (Efreq<-5.0) or (Efreq>40.00) then
         begin
           ShowMessage(floattostr(Efreq)+',DT');
         end;
     end else begin
       ShowMessage('Parameter Error !!');
     end;

   StrBuf:= Format('%S',[CNStr]);
   Result:=StrBuf;
end;

Function  TFormModify.NoiseBWStr(ADopplerFrq:Extended):String;
var i:integer;
   StrBuf:String;
begin
   if (ADopplerFrq<0.43) or (ADopplerFrq>9.99) then
   begin
      ShowMessage(Floattostr(ADopplerFrq)+',DT');
   end;

   StrBuf:= Format('%1.2f',[ADopplerFrq]);

   for i:=1 to 4 do
    if StrBuf[i]=' ' then StrBuf[i]:='0';

   Result:=StrBuf;
end;

procedure TFormModify.ModifyComboBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  key := 0;
end;

procedure TFormModify.ModifyComboBoxKeyPress(Sender: TObject;
  var Key: Char);
begin
  key := chr(0);
end;

procedure TFormModify.ModifyComboBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  key := 0;
end;

end.

